//You can pass function to functions quite easily, using function value objects

def totalSelectedValues(numbers, selector) {
  def total = 0
  for(i in numbers) {
    if (selector(i)) total += i
  }
  total
}

def numbers = [1, 2, 3, 4, 5]
println(totalSelectedValues(numbers) { true }) // total all numbers
                                   
println(totalSelectedValues(numbers) { e -> e % 2 == 0}) //total only even numbers
                                   
println(totalSelectedValues(numbers) { e -> e % 2 != 0}) //total only odd numbers
                                   
println(totalSelectedValues(numbers) { it > 4 }) //total only greater than 4 numbers

